package com.service.demo_bank_paysprint;

import androidx.annotation.LongDef;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.service.finopayment.Hostnew;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.Random;

public class MainActivity extends AppCompatActivity {

    Button btnBalanceEnquiry,btnCashWithdraw;
    EditText etAmount;
    TextView tvMessage;
    LinearLayout succes,fail;
    TextView balance,txn,rrn,messagesucces,messagefail,cardnumber;
    char[] chars = new char[]{ 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z',
            'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z',
            '1', '2', '3', '4', '5', '6', '7', '8', '9', '0' };

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        initViews();

        btnBalanceEnquiry.setOnClickListener(v->
        {
            HIT_SDK("ATMBE","00");
        });

        btnCashWithdraw.setOnClickListener(v->
        {

            if (!TextUtils.isEmpty(etAmount.getText().toString()))
            {
                String amount=etAmount.getText().toString().trim();
                HIT_SDK("ATMCW",amount);
            }
            else
            {
                etAmount.setError("Required");
            }


        });


    }

    private void initViews() {
        btnBalanceEnquiry=findViewById(R.id.BE);
        btnCashWithdraw=findViewById(R.id.CW);
        etAmount=findViewById(R.id.et_amount);
        tvMessage=findViewById(R.id.tv_message);
        succes  =   (LinearLayout)findViewById(R.id.successviews);
        fail =   (LinearLayout)findViewById(R.id.failview);
        balance  =  findViewById(R.id.balance);
        cardnumber  =  findViewById(R.id.card);
        txn  =  findViewById(R.id.txnstatus);
        rrn  =  findViewById(R.id.rrn);
        messagesucces  =  findViewById(R.id.message);
        messagefail    =  findViewById(R.id.messagefail);
    }
    private void HIT_SDK(String txntype,String amount) {

        Intent intent = new Intent(getApplicationContext(), Hostnew.class);
        intent.putExtra("partnerId", "PS0031");
        intent.putExtra("apiKey", "UFMwMDMxYTFjOGVmYjRhYjA0MGI0MWVmY2Q0MzY0YzRkZjg1NTM=");
        intent.putExtra("transactionType", txntype);
        intent.putExtra("amount", amount);
        intent.putExtra("merchantCode", "saurav1234");
        intent.putExtra("remarks", "Test Transaction");
        intent.putExtra("mobileNumber", "9560620395");
        intent.putExtra("referenceNumber", getRandomString(5, chars));
        intent.putExtra("latitude", "22.572646");
        intent.putExtra("longitude", "88.363895");
        intent.putExtra("subMerchantId", "saurav1234");
        intent.putExtra("deviceManufacturerId", "3");
        startActivityForResult(intent, 999);

    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, @Nullable Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == 999) {
            if (resultCode == Activity.RESULT_OK) {
                if (data != null) {

                    boolean status = data.getBooleanExtra("status", false);
                    int response = data.getIntExtra("response", 0);
                    String message = data.getStringExtra("message");
                    if (status) {
                        try {
                            JSONObject jsonObject = new JSONObject(String.valueOf(data.getStringExtra("JSONDATA")));
                            succes.setVisibility(View.VISIBLE);
                            fail.setVisibility(View.GONE);
                            rrn.setText(jsonObject.getString("bankRrn"));
                            balance.setText(jsonObject.getString("balAmount"));
                            txn.setText(jsonObject.getString("txnid"));
                            messagesucces.setText(jsonObject.getString("response"));
                            cardnumber.setText(jsonObject.getString("cardNumber"));
                            Toast.makeText(getApplicationContext(), "" + message, Toast.LENGTH_LONG).show();
                            Log.d( " RESULTS",jsonObject.toString());
                        } catch (JSONException jsonException) {
                            Log.d( " RESULTS",jsonException.toString());
                            jsonException.printStackTrace();
                        }
                    } else {
                        fail.setVisibility(View.VISIBLE);
                        messagefail.setText(message);
                        succes.setVisibility(View.GONE);
                        Toast.makeText(getApplicationContext(), "" + message, Toast.LENGTH_LONG).show();
                        Log.d( " RESULTS",message.toString());
                    }


                } else {

                    Toast.makeText(getApplicationContext(), "" + data.toString(), Toast.LENGTH_LONG).show();
                    Log.d( " RESULTS",data.toString());
                }
            }

        }


    }

    public String getRandomString(int length, char[] characterSet) {
        StringBuilder sb = new StringBuilder();

        for (int loop = 0; loop < length; loop++) {
            int index = new Random().nextInt(characterSet.length);
            sb.append(characterSet[index]);
        }

        String nonce = sb.toString();
        return nonce;
    }

}